const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_movements = sequelize.define(
    'inventory_movements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

movement_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"in",


"out",


"adjustment"

        ],

      },

quantity: {
        type: DataTypes.INTEGER,
      
      

      },

reference: {
        type: DataTypes.TEXT,
      
      

      },

note: {
        type: DataTypes.TEXT,
      
      

      },

moved_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_movements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.inventory_movements.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.inventory_movements.belongsTo(db.product_variants, {
      as: 'variant',
      foreignKey: {
        name: 'variantId',
      },
      constraints: false,
    });




    db.inventory_movements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_movements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_movements;
};


